Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -1997,66 +3004,90 @@
 		   ((match-beginning 4) 'font-lock-type-face)
 		   (t 'font-lock-variable-name-face))
 	   nil t))
+     ;;
+     ;; Emacs Lisp autoload cookies.
+     '("^;;;###\\(autoload\\)" 1 font-lock-warning-face prepend)
    )
  "Subdued level highlighting Lisp modes.")
 
+;; Macro to break up generated regexp-opt strings for easier reading and
+;; substitution into code, if we go back to expanding the regexp-opt call
+;; manually.
+;;
+;;(setq last-kbd-macro
+;;      (read-kbd-macro "\" C-7 C-1 <right> C-r \\\\| 3*<right> \" RET"))
+
 (defconst lisp-font-lock-keywords-2
   (append lisp-font-lock-keywords-1
-   (list
-    ;;
-    ;; Control structures.  ELisp and CLisp combined.
-    ;;
-    (cons
-     (concat
-      "(\\("
-      ;; beginning of generated stuff
-      ;; to regenerate, use the regexp-opt below, then delete the outermost
-      ;; grouping, then use the macro below to break up the string.
-      ;; (regexp-opt
-      ;;   '("cond" "if" "while" "let" "let*" "prog" "progn" "prog1"
-      ;;     "prog2" "progv" "catch" "throw" "save-restriction"
-      ;;     "save-excursion" "save-window-excursion"
-      ;;     "save-current-buffer" "with-current-buffer"
-      ;;     "save-selected-window" "with-selected-window"
-      ;;     "save-selected-frame" "with-selected-frame"
-      ;;     "with-temp-file" "with-temp-buffer" "with-output-to-string"
-      ;;     "with-string-as-buffer-contents"
-      ;;     "save-match-data" "unwind-protect" "call-with-condition-handler"
-      ;;     "condition-case" "track-mouse" "autoload"
-      ;;     "eval-after-load" "eval-and-compile" "eval-when-compile"
-      ;;     "when" "unless" "do" "dolist" "dotimes" "flet" "labels"
-      ;;     "lambda" "block" "return" "return-from" "loop") t)
-      ;; (setq last-kbd-macro
-      ;;   (read-kbd-macro "\" C-6 C-9 <right> C-r \\\\| 3*<right> \" RET"))
-      "autoload\\|block\\|c\\(?:a\\(?:ll-with-condition-handler\\|tch\\)\\|"
-      "ond\\(?:ition-case\\)?\\)\\|do\\(?:list\\|times\\)?\\|"
-      "eval-\\(?:a\\(?:fter-load\\|nd-compile\\)\\|when-compile\\)\\|flet\\|"
-      "if\\|l\\(?:a\\(?:bels\\|mbda\\)\\|et\\*?\\|oop\\)\\|prog[12nv]?\\|"
-      "return\\(?:-from\\)?\\|save-\\(?:current-buffer\\|excursion\\|"
-      "match-data\\|restriction\\|selected-\\(?:frame\\|window\\)\\|"
-      "window-excursion\\)\\|t\\(?:hrow\\|rack-mouse\\)\\|un\\(?:less\\|"
-      "wind-protect\\)\\|w\\(?:h\\(?:en\\|ile\\)\\|ith-\\(?:current-buffer\\|"
-      "output-to-string\\|s\\(?:elected-\\(?:frame\\|window\\)\\|"
-      "tring-as-buffer-contents\\)\\|temp-\\(?:buffer\\|file\\)\\)\\)"
-      ;; end of generated stuff
-      "\\)\\>") 1)
-    ;;
-    ;; Feature symbols as references.
-    '("(\\(featurep\\|provide\\|require\\)\\>[ \t']*\\(\\sw+\\)?"
-      (1 font-lock-keyword-face) (2 font-lock-reference-face nil t))
-    ;;
-    ;; Words inside \\[] tend to be for `substitute-command-keys'.
-    '("\\\\\\\\\\[\\(\\sw+\\)]" 1 font-lock-reference-face prepend)
-    ;;
-    ;; Words inside `' tend to be symbol names.
-    '("`\\(\\sw\\sw+\\)'" 1 font-lock-reference-face prepend)
-    ;;
-    ;; CLisp `:' keywords as references.
-    '("\\<:\\sw+\\>" 0 font-lock-reference-face prepend)
-    ;;
-    ;; ELisp and CLisp `&' keywords as types.
-    '("\\<\\&\\(optional\\|rest\\|whole\\)\\>" . font-lock-type-face)
-    ))
+   (eval-when-compile
+     (list
+      ;;
+      ;; Control structures.  Emacs Lisp forms.
+      (cons (concat
+	     "(" (regexp-opt
+		  '("cond" "if" "while" "let" "let*"
+		    "prog" "progn" "progv" "prog1" "prog2" "prog*"
+		    "inline" "lambda" "save-restriction" "save-excursion"
+		    "save-window-excursion" "save-selected-window"
+		    "save-match-data" "save-current-buffer" "unwind-protect"
+		    "condition-case" "track-mouse"
+		    "eval-after-load" "eval-and-compile" "eval-when-compile"
+		    "eval-when"
+		    "with-current-buffer" "with-electric-help"
+		    "with-output-to-string" "with-output-to-temp-buffer"
+		    "with-temp-buffer" "with-temp-file" "with-temp-message"
+		    "with-timeout"
+		    ;; XEmacs additions:
+		    "catch" "throw" "with-selected-window"
+		    "save-selected-frame" "with-selected-frame"
+		    "with-string-as-buffer-contents"
+		    "call-with-condition-handler"
+		    "autoload"
+		    ) t)
+	     "\\>")
+	    1)
+      ;;
+      ;; Control structures.  Common Lisp forms.
+      (cons (concat
+	     "(" (regexp-opt
+		  '("when" "unless" "case" "ecase" "typecase" "etypecase"
+		    "ccase" "ctypecase" "handler-case" "handler-bind"
+		    "restart-bind" "restart-case" "in-package"
+		    "cerror" "break" "ignore-errors"
+		    "loop" "do" "do*" "dotimes" "dolist" "the" "locally"
+		    "proclaim" "declaim" "declare" "symbol-macrolet"
+		    "lexical-let" "lexical-let*" "flet" "labels" "compiler-let"
+		    "destructuring-bind" "macrolet" "tagbody" "block"
+		    "return" "return-from") t)
+	     "\\>")
+	    1)
+      ;;
+      ;; Exit/Feature symbols as constants.
+      (list (concat "(\\(catch\\|throw\\|featurep\\|provide\\|require\\)\\>"
+		    "[ \t']*\\(\\sw+\\)?")
+	    '(1 font-lock-keyword-face)
+	    '(2 font-lock-constant-face nil t))
+      ;;
+      ;; Erroneous structures.
+      '("(\\(abort\\|assert\\|error\\|signal\\)\\>" 1 font-lock-warning-face)
+      ;;
+      ;; Words inside \\[] tend to be for `substitute-command-keys'.
+      '("\\\\\\\\\\[\\(\\sw+\\)]" 1 font-lock-constant-face prepend)
+      ;;
+      ;; Words inside `' tend to be symbol names.
+      '("`\\(\\sw\\sw+\\)'" 1 font-lock-constant-face prepend)
+      ;;
+      ;; Constant values.
+      '("\\<:\\sw\\sw+\\>" 0 font-lock-builtin-face)
+      ;;
+      ;; ELisp and CLisp `&' keywords as types.
+      ;; Former XEmacs version:
+      ;; '("\\<\\&\\(optional\\|rest\\|whole\\)\\>" . font-lock-type-face)
+      '("\\&\\sw+\\>" . font-lock-type-face)
+      ;;
+      ;; CL `with-' and `do-' constructs
+      '("(\\(\\(do-\\|with-\\)\\(\\s_\\|\\w\\)*\\)" 1 font-lock-keyword-face)
+      )))
   "Gaudy level highlighting for Lisp modes.")
 
 (defvar lisp-font-lock-keywords lisp-font-lock-keywords-1
@@ -2106,56 +3137,64 @@
 ;
 ;This does a lot more highlighting.")
 
-(defvar scheme-font-lock-keywords
+(defconst scheme-font-lock-keywords-1
   (eval-when-compile
     (list
      ;;
      ;; Declarations.  Hannes Haug <hannes.haug@student.uni-tuebingen.de> says
      ;; this works for SOS, STklos, SCOOPS, Meroon and Tiny CLOS.
-     (list (concat "(\\(define\\("
+     (list (concat "(\\(define\\*?\\("
 		   ;; Function names.
-		   "\\(\\|-\\(generic\\(\\|-procedure\\)\\|method\\)\\)\\|"
+		   "\\(\\|-public\\|-method\\|-generic\\(-procedure\\)?\\)\\|"
 		   ;; Macro names, as variable names.  A bit dubious, this.
-		   "\\(-syntax\\)\\|"
+		   "\\(-syntax\\|-macro\\)\\|"
 		   ;; Class names.
-		   "\\(-class\\)"
+		   "-class"
+                   ;; Guile modules.
+                   "\\|-module"
 		   "\\)\\)\\>"
 		   ;; Any whitespace and declared object.
 		   "[ \t]*(?"
 		   "\\(\\sw+\\)?")
 	   '(1 font-lock-keyword-face)
-	   '(8 (cond ((match-beginning 3) 'font-lock-function-name-face)
-		     ((match-beginning 6) 'font-lock-variable-name-face)
-		     (t 'font-lock-type-face))
+	   '(6 (cond ((match-beginning 3) font-lock-function-name-face)
+		     ((match-beginning 5) font-lock-variable-name-face)
+		     (t font-lock-type-face))
 	       nil t))
-     ;;
-     ;; Control structures.
-;(regexp-opt '("begin" "call-with-current-continuation" "call/cc"
-;	       "call-with-input-file" "call-with-output-file" "case" "cond"
-;	       "do" "else" "for-each" "if" "lambda"
-;	       "let\\*?" "let-syntax" "letrec" "letrec-syntax"
-;	       ;; Hannes Haug <hannes.haug@student.uni-tuebingen.de> wants:
-;	       "and" "or" "delay"
-;	       ;; Stefan Monnier <stefan.monnier@epfl.ch> says don't bother:
-;	       ;;"quasiquote" "quote" "unquote" "unquote-splicing"
-;	       "map" "syntax" "syntax-rules"))
-     (cons
-      (concat "(\\("
-	      "and\\|begin\\|c\\(a\\(ll\\(-with-\\(current-continuation\\|"
-	      "input-file\\|output-file\\)\\|/cc\\)\\|se\\)\\|ond\\)\\|"
-	      "d\\(elay\\|o\\)\\|else\\|for-each\\|if\\|"
-	      "l\\(ambda\\|et\\(-syntax\\|\\*?\\|rec\\(\\|-syntax\\)\\)\\)\\|"
-	      "map\\|or\\|syntax\\(\\|-rules\\)"
-	      "\\)\\>") 1)
-     ;;
-     ;; David Fox <fox@graphics.cs.nyu.edu> for SOS/STklos class specifiers.
-     '("\\<<\\sw+>\\>" . font-lock-type-face)
-     ;;
-     ;; Scheme `:' keywords as references.
-     '("\\<:\\sw+\\>" . font-lock-reference-face)
      ))
-"Default expressions to highlight in Scheme modes.")
+  "Subdued expressions to highlight in Scheme modes.")
 
+(defconst scheme-font-lock-keywords-2
+  (append scheme-font-lock-keywords-1
+   (eval-when-compile
+     (list
+      ;;
+      ;; Control structures.
+      (cons
+       (concat
+	"(" (regexp-opt
+	     '("begin" "call-with-current-continuation" "call/cc"
+	       "call-with-input-file" "call-with-output-file" "case" "cond"
+	       "do" "else" "for-each" "if" "lambda"
+	       "let" "let*" "let-syntax" "letrec" "letrec-syntax"
+	       ;; Hannes Haug <hannes.haug@student.uni-tuebingen.de> wants:
+	       "and" "or" "delay"
+	       ;; Stefan Monnier <stefan.monnier@epfl.ch> says don't bother:
+	       ;;"quasiquote" "quote" "unquote" "unquote-splicing"
+	       "map" "syntax" "syntax-rules") t)
+	"\\>") 1)
+      ;;
+      ;; David Fox <fox@graphics.cs.nyu.edu> for SOS/STklos class specifiers.
+      '("\\<<\\sw+>\\>" . font-lock-type-face)
+      ;;
+      ;; Scheme `:' keywords as builtins.
+      '("\\<:\\sw+\\>" . font-lock-builtin-face)
+      )))
+  "Gaudy expressions to highlight in Scheme modes.")
+
+(defvar scheme-font-lock-keywords scheme-font-lock-keywords-1
+  "Default expressions to highlight in Scheme modes.")
+
 ;; The previous version, before replacing it with the FSF version.
 ;(defconst scheme-font-lock-keywords (purecopy
 ; '(("(define[ \t]+(?\\([^ \t\n\)]+\\)" 1 font-lock-function-name-face)
@@ -2164,126 +3203,173 @@
 ;   ("(\\(quote\\|unquote\\|quasiquote\\|unquote-splicing\\)[ \t\n]" . 1)
 ;   ("(\\(syntax\\|syntax-rules\\|define-syntax\\|let-syntax\\|letrec-syntax\\)[ \t\n]" . 1)))
 ;  "Expressions to highlight in Scheme buffers.")
-
-(defconst c-font-lock-keywords-1 nil
-  "Subdued level highlighting for C modes.")
 
-(defconst c-font-lock-keywords-2 nil
-  "Medium level highlighting for C modes.")
+(put 'lisp-mode 'font-lock-defaults
+     '((lisp-font-lock-keywords
+        lisp-font-lock-keywords-1 lisp-font-lock-keywords-2)
+       nil nil (("+-*/.<>=!?$%_&~^:" . "w")) beginning-of-defun
+       (font-lock-mark-block-function . mark-defun)))
+(put 'emacs-lisp-mode 'font-lock-defaults 'lisp-mode)
+(put 'lisp-interaction-mode 'font-lock-defaults 'lisp-mode)
 
-(defconst c-font-lock-keywords-3 nil
-  "Gaudy level highlighting for C modes.")
+(put 'scheme-mode 'font-lock-defaults
+     '((scheme-font-lock-keywords
+	scheme-font-lock-keywords-1 scheme-font-lock-keywords-2)
+       nil t (("+-*/.<>=!?$%_&~^:" . "w")) beginning-of-defun
+       (font-lock-mark-block-function . mark-defun)))
+(put 'inferior-scheme-mode 'font-lock-defaults 'scheme-mode)
+(put 'scheme-interaction-mode 'font-lock-defaults 'scheme-mode)
 
-(defconst xemacs-c-font-lock-keywords-2 nil
-  "Medium level highlighting for XEmacs C source code.")
+
+;;; User choices.
 
-(defconst xemacs-c-font-lock-keywords-3 nil
-  "Gaudy level highlighting for XEmacs C source code.")
+;; These provide a means to fontify types not defined by the language.  Those
+;; types might be the user's own or they might be generally accepted and used.
+;; Generally accepted types are used to provide default variable values.
+
+(define-widget 'font-lock-extra-types-widget 'radio
+  "Widget `:type' for members of the custom group `font-lock-extra-types'.
+Members should `:load' the package `font-lock' to use this widget."
+:args '((const :tag "none" nil)
+	  (repeat :tag "types" regexp)))
+
+(defcustom c-font-lock-extra-types '("FILE" "\\sw+_t" "Lisp_Object")
+  "*List of extra types to fontify in C mode.
+Each list item should be a regexp not containing word-delimiters.
+For example, a value of (\"FILE\" \"\\\\sw+_t\") means the word FILE and words
+ending in _t are treated as type names.
+
+The value of this variable is used when Font Lock mode is turned on."
+:type 'font-lock-extra-types-widget
+:group 'font-lock-extra-types)
+
+(defconst xemacs-c-font-lock-extra-types
+  '("FILE" "\\sw+_t"
+    "Ibyte" "CIbyte" "Extbyte" "UExtbyte" "WExtbyte"
+    "Ascbyte" "UAscbyte" "Rawbyte" "CRawbyte" "Binbyte" "CBinbyte"
+    "SBinbyte" "Boolbyte" "Ichar" "Raw_Ichar" "Itext" "Textcount"
+    "Bytecount" "Charcount" "Charbpos" "Bytebpos" "Membpos" "Charxpos"
+    "Bytexpos" "Memxpos" "Elemcount" "Hashcode" "EMACS_INT" "USID"
+    "face_index" "glyph_index" "Lisp_Object")
+  "Value of `c-font-lock-extra-types' appropriate for XEmacs source code.")
+
+(defcustom c++-font-lock-extra-types
+  '("\\sw+_t"
+    "\\([iof]\\|str\\)+stream\\(buf\\)?" "ios"
+    "string" "rope"
+    "list" "slist"
+    "deque" "vector" "bit_vector"
+    "set" "multiset"
+    "map" "multimap"
+    "hash\\(_\\(m\\(ap\\|ulti\\(map\\|set\\)\\)\\|set\\)\\)?"
+    "stack" "queue" "priority_queue"
+    "type_info"
+    "iterator" "const_iterator" "reverse_iterator" "const_reverse_iterator"
+    "reference" "const_reference")
+  "*List of extra types to fontify in C++ mode.
+Each list item should be a regexp not containing word-delimiters.
+For example, a value of (\"string\") means the word string is treated as a type
+name.
+
+The value of this variable is used when Font Lock mode is turned on."
+:type 'font-lock-extra-types-widget
+:group 'font-lock-extra-types)
+
+(defcustom objc-font-lock-extra-types '("Class" "BOOL" "IMP" "SEL")
+  "*List of extra types to fontify in Objective-C mode.
+Each list item should be a regexp not containing word-delimiters.
+For example, a value of (\"Class\" \"BOOL\" \"IMP\" \"SEL\") means the words
+Class, BOOL, IMP and SEL are treated as type names.
+
+The value of this variable is used when Font Lock mode is turned on."
+:type 'font-lock-extra-types-widget
+:group 'font-lock-extra-types)
+
+(defcustom java-font-lock-extra-types
+  '("[A-Z\300-\326\330-\337]\\sw*[a-z]\\sw*")
+  "*List of extra types to fontify in Java mode.
+Each list item should be a regexp not containing word-delimiters.
+For example, a value of (\"[A-Z\300-\326\330-\337]\\\\sw*[a-z]\\\\sw*\") means capitalised
+words (and words conforming to the Java id spec) are treated as type names.
+
+The value of this variable is used when Font Lock mode is turned on."
+:type 'font-lock-extra-types-widget
+:group 'font-lock-extra-types)
+
+;;; C.
 
-(defconst c++-font-lock-keywords-1 nil
-  "Subdued level highlighting for C++ modes.")
+;; [Murmur murmur murmur] Maestro, drum-roll please...  [Murmur murmur murmur.]
+;; Ahem.  [Murmur murmur murmur] Lay-dees an Gennel-men.  [Murmur murmur shhh!]
+;; I am most proud and humbly honoured today [murmur murmur cough] to present
+;; to you good people, the winner of the Second Millennium Award for The Most
+;; Hairy Language Syntax.  [Ahhh!]  All rise please.  [Shuffle shuffle
+;; shuffle.]  And a round of applause please.  For...  The C Language!  [Roar.]
+;;
+;; Thank you...  You are too kind...  It is with a feeling of great privilege
+;; and indeed emotion [sob] that I accept this award.  It has been a long hard
+;; road.  But we know our destiny.  And our future.  For we must not rest.
+;; There are more tokens to overload, more shoehorn, more methodologies.  But
+;; more is a plus!  [Ha ha ha.]  And more means plus!  [Ho ho ho.]  The future
+;; is C++!  [Ohhh!]  The Third Millennium Award...  Will be ours!  [Roar.]
 
-(defconst c++-font-lock-keywords-2 nil
-  "Medium level highlighting for C++ modes.")
+(defconst c-font-lock-keywords-1 nil
+  "Subdued level highlighting for C mode.")
 
-(defconst c++-font-lock-keywords-3 nil
-  "Gaudy level highlighting for C++ modes.")
+(defconst c-font-lock-keywords-2 nil
+  "Medium level highlighting for C mode.
+See also `c-font-lock-extra-types'.")
 
-(defun font-lock-match-c++-style-declaration-item-and-skip-to-next (limit)
-  ;; Match, and move over, any declaration/definition item after point.
-  ;; The expect syntax of an item is "word" or "word::word", possibly ending
-  ;; with optional whitespace and a "(".  Everything following the item (but
-  ;; belonging to it) is expected to by skip-able by `forward-sexp', and items
-  ;; are expected to be separated with a "," or ";".
-  (if (looking-at "[ \t*&]*\\(\\(?:\\sw\\|\\s_\\)+\\)\\(::\\(\\(?:\\sw\\|\\s_\\)+\\)\\)?[ \t]*\\((\\)?")
-      (save-match-data
-	(condition-case nil
-	    (save-restriction
-	      ;; Restrict to the end of line, currently guaranteed to be LIMIT.
-	      (narrow-to-region (point-min) limit)
-	      (goto-char (match-end 1))
-	      ;; Move over any item value, etc., to the next item.
-	      (while (not (looking-at "[ \t]*\\([,;]\\|$\\)"))
-		(goto-char (or (scan-sexps (point) 1) (point-max))))
-	      (goto-char (match-end 0)))
-	  (error t)))))
+(defconst c-font-lock-keywords-3 nil
+  "Gaudy level highlighting for C mode.
+See also `c-font-lock-extra-types'.")
 
-(let ((c-keywords
-;      ("break" "continue" "do" "else" "for" "if" "return" "switch" "while")
-       "break\\|continue\\|do\\|else\\|for\\|if\\|return\\|switch\\|while")
-      (xemacs-c-type-types
-      ;(regexp-opt '("Ibyte" "CIbyte" "Extbyte" "UExtbyte" "WExtbyte"
-      ; "Ascbyte" "UAscbyte" "Rawbyte" "CRawbyte" "Binbyte" "CBinbyte"
-      ; "SBinbyte" "Boolbyte" "Ichar" "Raw_Ichar" "Itext" "Textcount"
-      ; "Bytecount" "Charcount" "Charbpos" "Bytebpos" "Membpos" "Charxpos"
-      ; "Bytexpos" "Memxpos" "Elemcount" "Hashcode" "EMACS_INT" "USID"
-      ; "face_index" "glyph_index" "Lisp_Object"))
-       ;; see below (search for last-kbd-macro) for how to auto-generate
-       ;; what's below from what's above.
-       (concat
-	"Ascbyte\\|B\\(?:inbyte\\|oolbyte\\|yte\\(?:bpos\\|count\\|"
-	"xpos\\)\\)\\|C\\(?:Binbyte\\|Ibyte\\|Rawbyte\\|har\\(?:bpos\\|"
-	"count\\|xpos\\)\\)\\|E\\(?:MACS_INT\\|lemcount\\|xtbyte\\)\\|"
-	"Hashcode\\|I\\(?:byte\\|char\\|text\\)\\|Lisp_Object\\|"
-	"Mem\\(?:bpos\\|xpos\\)\\|Raw\\(?:_Ichar\\|byte\\)\\|SBinbyte\\|"
-	"Textcount\\|U\\(?:Ascbyte\\|Extbyte\\|SID\\)\\|WExtbyte\\|"
-	"face_index\\|glyph_index"))
-      (c-type-types
-;      ("auto" "extern" "register" "static" "typedef" "struct" "union" "enum"
-;	"signed" "unsigned" "short" "long" "int" "char" "wchar_t" "float"
-;       "double" "void" "volatile" "const")
-       ;; This regexp is (just) 6 parens deep ...
-       ;; This regexp is (just) 6 parens deep ...
-       ;; This regexp is (just) 6 parens deep ...
-       ;; repeat ad nauseum
-       (concat "auto\\|c\\(har\\|onst\\)\\|double\\|e\\(num\\|xtern\\)\\|"
-	       "float\\|int\\|long\\|register\\|"
-	       "s\\(hort\\|igned\\|t\\(atic\\|ruct\\)\\)\\|typedef\\|"
-	       "un\\(ion\\|signed\\)\\|vo\\(id\\|latile\\)\\|wchar_t"))
-      (c++-keywords
-;      ("break" "continue" "do" "else" "for" "if" "return" "switch" "while"
-;	"asm" "catch" "delete" "new" "operator" "sizeof" "this" "throw" "try"
-;       "protected" "private" "public" "const_cast" "dynamic_cast" "reinterpret_cast"
-;       "static_cast" "and" "bitor" "or" "xor" "compl" "bitand" "and_eq"
-;	"or_eq" "xor_eq" "not" "not_eq" "typeid" "false" "true")
-       (concat "a\\(nd\\(\\|_eq\\)\\|sm\\)\\|"
-	       "b\\(it\\(or\\|and\\)\\|reak\\)\\|"
-	       "c\\(atch\\|o\\(mpl\\|n\\(tinue\\|st_cast\\)\\)\\)\\|"
-	       "d\\(elete\\|o\\|ynamic_cast\\)\\|"
-	       "else\\|"
-	       "f\\(alse\\|or\\)\\|if\\|"
-	       "n\\(ew\\|ot\\(\\|_eq\\)\\)\\|"
-	       "p\\(r\\(ivate\\|otected\\)\\|ublic\\)\\|"
-	       "or\\(\\|_eq\\)\\|"
-	       "re\\(interpret_cast\\|turn\\)\\|"
-	       "s\\(izeof\\|tatic_cast\\|witch\\)\\|"
-	       "t\\(h\\(is\\|row\\)\\|r\\(ue\\|y\\)\\|ypeid\\)\\|"
-	       "xor\\(\\|_eq\\)\\|while"))
-      (c++-type-types
-;      ("auto" "extern" "register" "static" "typedef" "struct" "union" "enum"
-;	"signed" "unsigned" "short" "long" "int" "char" "float" "double"
-;	"void" "volatile" "const" "class" "inline" "friend" "bool"
-;	"virtual" "complex" "template" "explicit" "mutable" "export" "namespace"
-;       "using" "typename" "wchar_t")
-       (concat "auto\\|bool\\|c\\(har\\|lass\\|o\\(mplex\\|nst\\)\\)\\|"
-	       "double\\|"
-	       "e\\(num\\|x\\(p\\(licit\\|ort\\)\\|tern\\)\\)\\|"
-	       "f\\(loat\\|riend\\)\\|"
-	       "in\\(line\\|t\\)\\|long\\|mutable\\|namespace\\|register\\|"
-	       "s\\(hort\\|igned\\|t\\(atic\\|ruct\\)\\)\\|"
-	       "t\\(emplate\\|ype\\(def\\|name\\)\\)\\|"
-	       "u\\(\\(n\\(ion\\|signed\\)\\|sing\\)\\)\\|"
-	       "v\\(irtual\\|o\\(id\\|latile\\)\\)\\|"
-	       "wchar_t"))		; 11 ()s deep.
-      (ctoken "\\(\\sw\\|\\s_\\|[:~*&]\\)+")
-      )
+(let* ((c-keywords
+	(eval-when-compile
+	  (regexp-opt '("break" "continue" "do" "else" "for" "if" "return"
+			"switch" "while" "sizeof"
+			;; Type related, but we don't do anything special.
+			"typedef" "extern" "auto" "register" "static"
+			"volatile" "const"
+			;; Dan Nicolaescu <done@gnu.org> says this is new.
+			"restrict"))))
+       (c-type-specs
+	(eval-when-compile
+	  (regexp-opt '("enum" "struct" "union"))))
+       (c-type-specs-depth
+	(regexp-opt-depth c-type-specs))
+       (c-type-names
+	`(mapconcat 'identity
+	  (cons
+	   ,(eval-when-compile
+	      (regexp-opt
+	       '("char" "short" "int" "long" "signed" "unsigned"
+		 "float" "double" "void" "complex")))
+	   c-font-lock-extra-types)
+	  "\\|"))
+       (c-type-names-depth
+	`(regexp-opt-depth ,c-type-names))
+       (c-preprocessor-directives
+	(eval-when-compile
+	  (regexp-opt
+	   '("define"  "elif" "else" "endif" "error" "file" "if" "ifdef"
+	     "ifndef" "include" "line" "pragma" "undef"))))
+       (c-preprocessor-directives-depth
+	(regexp-opt-depth c-preprocessor-directives))
+       ;; XEmacs:
+       (ctoken "\\(\\sw\\|\\s_\\|[:~*&]\\)+"))
  (setq c-font-lock-keywords-1
   (list
    ;;
    ;; These are all anchored at the beginning of line for speed.
+   ;; Note that `c++-font-lock-keywords-1' depends on `c-font-lock-keywords-1'.
    ;;
    ;; Fontify function name definitions (GNU style; without type on line).
-   
+   ;;
+   ;; FSF 21.2 has:
+   ;'("^\\(\\sw+\\)[ \t]*(" 1 font-lock-function-name-face)
+   ;;
+   ;; We have all the following down to just before the error directives.
+
    ;; In FSF this has the simpler definition of "\\sw+" for ctoken.
    ;; I'm not sure if ours is more correct.
    ;; This is a subset of the next rule, and is slower when present. --dmoore
